const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const class_schedules = sequelize.define(
    'class_schedules',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

weekday: {
        type: DataTypes.ENUM,
      
      

        values: [

"monday",


"tuesday",


"wednesday",


"thursday",


"friday",


"saturday"

        ],

      },

period_label: {
        type: DataTypes.TEXT,
      
      

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

room: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  class_schedules.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.class_schedules.belongsTo(db.class_sections, {
      as: 'class_section',
      foreignKey: {
        name: 'class_sectionId',
      },
      constraints: false,
    });

    db.class_schedules.belongsTo(db.subjects, {
      as: 'subject',
      foreignKey: {
        name: 'subjectId',
      },
      constraints: false,
    });

    db.class_schedules.belongsTo(db.staff_members, {
      as: 'teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });




    db.class_schedules.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.class_schedules.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return class_schedules;
};


